
#include "parametres.h"
#include "conteneur.h"

int extract( QString p )
{
 int i=0,l,j=0 ;
 bool ok ;

 l = p.length() ;
 for(i=0;i<l;i++) if (p[i] == '=') break ;
 i++ ;
 QString t ;
 t.setLength(l-i) ;
 for(j=i;j<l;j++) t[j-i] =  p[j] ;
 return t.toInt(&ok,10) ;
}

parametres::parametres()
{
    textLabel1 = new QLabel( this, "textLabel1" );
    textLabel1->setGeometry( QRect( 20, 20, 50, 20 ) );

    textLabel2 = new QLabel( this, "textLabel2" );
    textLabel2->setGeometry( QRect( 20, 50, 120, 20 ) );

    textLabel3 = new QLabel( this, "textLabel3" );
    textLabel3->setGeometry( QRect( 20, 80, 107, 20 ) );

    groupBox2 = new QGroupBox( this, "groupBox2" );
    groupBox2->setGeometry( QRect( 20, 260, 270, 70 ) );

    pushButton2 = new QPushButton( groupBox2, "pushButton2" );
    pushButton2->setGeometry( QRect( 20, 20, 70, 30 ) );

    textLabel5 = new QLabel( groupBox2, "textLabel5" );
    textLabel5->setGeometry( QRect( 110, 20, 80, 20 ) );

    textLabel6 = new QLabel( groupBox2, "textLabel6" );
    textLabel6->setGeometry( QRect( 110, 40, 81, 20 ) );

    comboBox2 = new QComboBox( FALSE, groupBox2, "comboBox2" );
    comboBox2->setGeometry( QRect( 200, 30, 60, 30 ) );

    groupBox1 = new QGroupBox( this, "groupBox1" );
    groupBox1->setGeometry( QRect( 20, 110, 270, 140 ) );

    pushButton1 = new QPushButton( groupBox1, "pushButton1" );
    pushButton1->setGeometry( QRect( 10, 30, 80, 30 ) );

    pushButtonL = new QPushButton( groupBox1, "pushButtonL" );
    pushButtonL->setGeometry( QRect( 140, 30, 80, 30 ) );

    checkBox1 = new QCheckBox( groupBox1, "checkBox1" );
    checkBox1->setGeometry( QRect( 20, 70, 95, 22 ) );

    textLabel4 = new QLabel( groupBox1, "textLabel4" );
    textLabel4->setGeometry( QRect( 20, 100, 112, 20 ) );

    comboBox1 = new QComboBox( FALSE, groupBox1, "comboBox1" );
    comboBox1->setGeometry( QRect( 140, 90, 50, 30 ) );

    groupBox3 = new QGroupBox( this, "groupBox3" );
    groupBox3->setGeometry( QRect( 20, 340, 270, 60 ) );

    checkBox2 = new QCheckBox( groupBox3, "checkBox2" );
    checkBox2->setGeometry( QRect( 10, 30, 94, 22 ) );

    textLabel1_2 = new QLabel( this, "textLabel1_2" );
    textLabel1_2->setGeometry( QRect( 50, 420, 100, 20 ) );

    comboBox3 = new QComboBox( FALSE, this, "comboBox3" );
    comboBox3->setGeometry( QRect( 160, 410, 127, 30 ) );

//------------
    //resize( QSize(311, 454).expandedTo(minimumSizeHint()) );
	resize( QSize(311, 454) );
    //clearWState( WState_Polished );
    setMaximumSize(311,454) ;
    setMinimumSize(311,454) ;

    textLabel1->setText(  "Press :"  );
    textLabel2->setText(  "space to continue"  );
    textLabel3->setText(  "S to save image"  );
    groupBox2->setTitle(  "Root" );
    pushButton2->setText(  "Restart" );
    textLabel5->setText(  "pourcent of" );
    textLabel6->setText(  "white points" );
    comboBox2->clear();
    comboBox2->insertItem(  "0"  );
    comboBox2->insertItem(  "1"  );
    comboBox2->insertItem(  "5"  );
    comboBox2->insertItem(  "10"  );
    comboBox2->insertItem(  "20" );
    comboBox2->insertItem(  "30"  );
    comboBox2->insertItem(  "40" );
    comboBox2->insertItem(  "50"  );
    comboBox2->insertItem(  "60"  );
    comboBox2->insertItem(  "70"  );
    comboBox2->insertItem(  "80"  );
    comboBox2->insertItem(  "90"  );
    comboBox2->insertItem(  "95"  );
    comboBox2->insertItem(  "100"  );
    comboBox2->setCurrentItem ( 1 ) ;
    groupBox1->setTitle(  "Application"  );
    pushButton1->setText(  "Random"  );
    pushButtonL->setText(  "Load"  );
    checkBox1->setText(  "symmetric"  );
    textLabel4->setText(  "Nb of neighboors"  );
    comboBox1->clear();
    comboBox1->insertItem(  "4"  );
    comboBox1->insertItem(  "6"  );
    comboBox1->insertItem(  "8"  );
    comboBox1->insertItem(  "10"  );
    comboBox1->insertItem(  "12"  );
    comboBox1->insertItem(  "14"  );
    groupBox3->setTitle(  "bug ;-)"  );
    checkBox2->setText(  "without bug"  );
    textLabel1_2->setText( "size of image" );
    comboBox3->clear();
    comboBox3->insertItem( "128x511"  ) ;
    comboBox3->insertItem( "256x1031"  );
    comboBox3->insertItem( "512x2053"  );
    comboBox3->insertItem( "1024x4099"  );
    comboBox3->insertItem( "2048x8209"  );
    comboBox3->insertItem( "4096x16411"  );
    comboBox3->setCurrentItem ( 2 ) ;

    // initialisation application
    checkBox2->setChecked( true) ;  // without bug == true
    setFocusPolicy(QWidget::StrongFocus) ;


 _conteneur = new conteneur() ;
 _conteneur->setGeometry(0,0,800,512 ) ;
 _conteneur->show() ;

 QObject::connect(pushButton2,SIGNAL( clicked()),this,SLOT( slotRestart() ) ) ;
 QObject::connect(pushButton1,SIGNAL( clicked()),this,SLOT( slotRandom() ) ) ;
 QObject::connect(pushButtonL,SIGNAL( clicked()),this,SLOT( slotLoadAppli() ) ) ;
 QObject::connect(comboBox1,SIGNAL( activated(int)),this,SLOT( slotRandom() ) ) ;
 QObject::connect(checkBox1,SIGNAL( clicked()),this,SLOT( slotRandom() ) ) ;
 QObject::connect(comboBox2,SIGNAL( activated(int)),this,SLOT( slotRestart() ) ) ;

 QObject::connect( this,SIGNAL(signalRestart(int,bool)),_conteneur,SLOT(slotRestart(int,bool))) ;
 QObject::connect( this,SIGNAL(signalRandom(int,bool)),_conteneur,SLOT(slotRandom(int,bool))) ;
 QObject::connect( this,SIGNAL(signalCalculate()),_conteneur,SLOT(slotCalculate())) ;
 QObject::connect( this,SIGNAL(signalSaveImage()),_conteneur,SLOT(slotSaveImage())) ;
 QObject::connect( this,SIGNAL(signalLoadAppli(int*,int,int)),_conteneur,SLOT(slotLoadAppli(int*,int,int))) ;
 QObject::connect( checkBox2,SIGNAL(toggled(bool)),_conteneur,SLOT(slotBugChanged(bool)) ) ;
 QObject::connect( comboBox3,SIGNAL(activated(int)),_conteneur,SLOT(slotSizeChanged(int)) ) ;

}

/*
 *  Destroys the object and frees any allocated resources
 */
parametres :: ~parametres()
{
   delete _conteneur ;
}

void parametres :: slotRestart()
{
 int v ;
 //cout << "\n  parametres :: slotRestart " << endl ;
 //cout << comboBox2->currentItem() << endl ;
 switch (comboBox2->currentItem())
	{
	 case  0 : v = 0 ; break ;
	 case  1 : v = 1 ; break ;
	 case  2 : v = 5 ; break ;
	 case  3 : v = 10 ; break ;
	 case  4 : v = 20 ; break ;
	 case  5 : v = 30 ; break ;
	 case  6 : v = 40 ; break ;
	 case  7 : v = 50 ; break ;
	 case  8 : v = 60 ; break ;
	 case  9 : v = 70 ; break ;
	 case 10 : v = 80 ; break ;
	 case 11 : v = 90 ; break ;
	 case 12 : v = 95 ; break ;
	 case 13 : v = 100 ; break ;
	 default:  v = 50 ;
	}

 emit signalRestart( v, checkBox2->isChecked() ) ;
}

void parametres :: slotRandom()
{
 //cout << "\n  parametres :: slotRandom() " << endl ;
 //cout << comboBox1->currentItem() << endl ;
 emit signalRandom( comboBox1->currentItem()*2+4,checkBox1->isChecked() ) ;
 slotRestart() ;
}

void parametres :: keyPressEvent( QKeyEvent* event )
{
 int rep ;

 rep = event->key() ;

 if (rep == Qt::Key_Space )
	{
	 //cout << "\n Arhhhhhhhhhhhhh !!!!!!";
	 emit signalCalculate() ;
	}
 if (rep == Qt::Key_S )
	{
	 emit signalSaveImage() ;
	}

}

void parametres :: slotLoadAppli()
{
 QString filename = QFileDialog::getOpenFileName(".","*.txt",this) ;
 QString ligne ;
 int nbConfigurations,i,j,nbVoisins ;
 int* a ;
 bool ok ;


 if (!filename.isEmpty())
	{
	 QFile fappli(filename) ;
	 if (fappli.open( IO_ReadOnly ))
		{
		 QTextStream s( &fappli ) ;
		 ligne.setLength(256) ;
		 ligne = s.readLine() ;
		 nbConfigurations = extract(ligne) ;
		 //nbConfigurations = nb.toInt(&ok,10) ;
		 cout << " nbConfigurations = " << nbConfigurations  << endl ;
		 if (nbConfigurations<32) nbConfigurations = 32 ;
		 j = nbConfigurations ;
		 i=0 ;
		 while(j>1) { j >>= 1 ; i++ ; }
		 nbVoisins = i-1 ;
		 if (nbVoisins>14)
			{
			 nbVoisins = 14 ;
			 nbConfigurations = 1 << (nbVoisins+1) ;
			}

		 a = new int[nbConfigurations] ;
		 for(i=0;i<nbConfigurations;i++)
			{
			 ligne = s.readLine() ;
			 if (ligne==EOF) break ;
			 j = extract(ligne) ;
			 //cout << " p[" << i << "] = " << nb << endl ;
			 //j = nb.toInt(&ok,10) ;
			 //cout << " ok = " << ok << " j = " << j << endl ;
			 if ((j!=0) && (j!=1)) j = 0 ;
			 a[i] = j ;
			}
		 fappli.close() ;
		 j = nbConfigurations >> 1 ;
		 ok = true ;
		 for(i=j;i<nbConfigurations;i++)
			if (a[j]!=a[nbConfigurations-j-1])
				{
				 ok = false ;
				 break ;
				}
		 comboBox1->setCurrentItem((nbVoisins-4)>>1) ;
		 checkBox1->setChecked(ok) ;
		 emit signalLoadAppli( a,nbConfigurations,nbVoisins ) ;
		 slotRestart() ;
		 delete a ;
		}
		else QMessageBox::warning(0,"Error to read the file","impossoble to read the file" ) ;
	}
	else QMessageBox::warning(0,"Error to load the file","impossoble to load the file" ) ;
}

void parametres :: resizeEvent(QResizeEvent* e )
{
 //_scrollview->setGeometry(0,0,width(),height()) ;
}





